From cf6f08a799178bd5e83516a32d5dff4c6e4b51b8 Mon Sep 17 00:00:00 2001
From: Carl Huang <cjhuang@codeaurora.org>
Date: Wed, 11 Mar 2020 20:07:03 +0800
Subject: [PATCH 070/124] ath11k: add shutdown function in ath11k_pci_driver

During reboot, .shtudown is called so ath11k can reset MHI device.
Otherwise the QCA6390 isn't enumerated during starting.

Tested-on: QCA6390 WLAN.HST.1.0.1-01230-QCAHSTSWPLZ_V2_TO_X86-1

Change-Id: Ie436e509f2f7d8f13333c9f595775e0832a1195e
Signed-off-by: Carl Huang <cjhuang@codeaurora.org>
---
 drivers/net/wireless/ath/ath11k/pci.c | 8 ++++++++
 1 file changed, 8 insertions(+)

diff --git a/drivers/net/wireless/ath/ath11k/pci.c b/drivers/net/wireless/ath/ath11k/pci.c
index 3e1b03b..2734e75 100644
--- a/drivers/net/wireless/ath/ath11k/pci.c
+++ b/drivers/net/wireless/ath/ath11k/pci.c
@@ -1161,11 +1161,19 @@ static void ath11k_pci_remove(struct pci_dev *pdev)
 	ath11k_core_free(ab);
 }
 
+static void ath11k_pci_shutdown(struct pci_dev *pdev)
+{
+	struct ath11k_base *ab = pci_get_drvdata(pdev);
+
+	ath11k_pci_power_down(ab);
+}
+
 static struct pci_driver ath11k_pci_driver = {
 	.name = "ath11k_pci",
 	.id_table = ath11k_pci_id_table,
 	.probe = ath11k_pci_probe,
 	.remove = ath11k_pci_remove,
+	.shutdown = ath11k_pci_shutdown,
 };
 
 static int ath11k_pci_init(void)
-- 
2.7.4

